<template>
  <div class="example-avatar">
    <div v-show="$refs.upload && $refs.upload.dropActive" class="drop-active">
      <h3>Drop files to upload</h3>
    </div>
    <div v-show="!edit" class="avatar-upload">
      <div class="text-center p-2">
        <label for="avatar">
          <!-- <img
            :src="files.length ? files[0].url : require('~/assets/images/icon-account.png')"
            class="rounded-circle"
          /> -->
          <img
            :src="fileUrl ? fileUrl : require('~/assets/images/icon-account.png')"
            class="rounded-circle"
          />
          <h4 class="pt-2">Upload Avatar</h4>
          <h4 class="pt-2">Select or drop files anywhere to upload</h4>
        </label>
      </div>
      <div class="text-center p-2">
        <file-upload
          ref="upload"
          v-model="files"
          extensions="gif,jpg,jpeg,png,webp"
          accept="image/png,image/gif,image/jpeg,image/webp"
          name="avatar"
          class="btn btn-primary"
          post-action="/upload/post"
          :drop="!edit"
          @input-filter="inputFilter"
        >
        </file-upload>
      </div>
    </div>
  </div>
</template>

<script>
import FileUpload from 'vue-upload-component'
export default {
  components: { FileUpload },
  props: {
    fileUrl: {
      type: String,
      default: ''
    }
  },
  data() {
    return {
      files: [],
      edit: false
    }
  },
  methods: {
    inputFilter(newFile, oldFile, prevent) {
      if (newFile && !oldFile) {
        if (!/\.(gif|jpg|jpeg|png|webp)$/i.test(newFile.name)) {
          this.$toast.error('Your file is not a picture')
          return prevent()
        }
      }
      if (newFile && (!oldFile || newFile.file !== oldFile.file)) {
        newFile.url = ''
        const URL = window.URL || window.webkitURL
        if (URL && URL.createObjectURL) {
          newFile.url = URL.createObjectURL(newFile.file)
        }
      }
      this.$emit('input', newFile)
    }
  }
}
</script>

<style>
.example-avatar .avatar-upload .rounded-circle {
  width: 200px;
  height: 200px;
  border-radius: 50%;
}
.example-avatar .text-center .btn {
  margin: 0 0.5rem;
}

.example-avatar .drop-active {
  top: 0;
  bottom: 0;
  right: 0;
  left: 0;
  position: fixed;
  z-index: 9999;
  opacity: 0.6;
  text-align: center;
  background: #000;
}

.example-avatar .drop-active h3 {
  margin: -0.5em 0 0;
  position: absolute;
  top: 50%;
  left: 0;
  right: 0;
  -webkit-transform: translateY(-50%);
  -ms-transform: translateY(-50%);
  transform: translateY(-50%);
  font-size: 40px;
  color: #fff;
  padding: 0;
}
</style>
